//
// Trial.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Trial: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var userId: Int?
    public var mediaId: Int?
    public var result: String?
    public var updatedAt: Date?
    public var createdAt: Date?
    public var user: User?
    public var media: Media?

    public init(id: Int? = nil, userId: Int? = nil, mediaId: Int? = nil, result: String? = nil, updatedAt: Date? = nil, createdAt: Date? = nil, user: User? = nil, media: Media? = nil) {
        self.id = id
        self.userId = userId
        self.mediaId = mediaId
        self.result = result
        self.updatedAt = updatedAt
        self.createdAt = createdAt
        self.user = user
        self.media = media
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case userId
        case mediaId
        case result
        case updatedAt
        case createdAt
        case user = "User"
        case media = "Media"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(userId, forKey: .userId)
        try container.encodeIfPresent(mediaId, forKey: .mediaId)
        try container.encodeIfPresent(result, forKey: .result)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(user, forKey: .user)
        try container.encodeIfPresent(media, forKey: .media)
    }
}

